#ifndef AOITRACKING
#define AOITRACKING

#include "../core/datastate.h"
#include "Dense"

class AOItracking
{
public:
    AOItracking(DataState *state, bool interactive=false, int machtingAccuracy=18);
    int interactiveTracking(int breakFrame);
    void automaticTracking();
    QList<QPair<int,int> > getFramePairs();

private:
    QList<int> framePairsVector;
    struct aoiFittingWrapper {
      AOItracking *instance;
      // cppcheck-suppress noExplicitConstructor
      aoiFittingWrapper(AOItracking *w): instance(w) {}
      void operator()(int &iteration) {
        instance->aoiFitting(iteration);
      }
    };
    void aoiFitting(int &iteration);
    bool transformAOI(int frame1, int frame2);
    Eigen::Affine2d calculateTransform(Eigen::MatrixXd pointsFrame1,Eigen::MatrixXd pointsFrame2,Eigen::MatrixXd pointsDistance);

    QList<QPair<int,int> > framePairs;
    volatile bool breakThread = false;
    volatile int breakFrame = -1;
    const int machtingAccuracy;
    const bool interactive;

    DataState *state;
};

#endif // AOITRACKING

