#include <QDebug>
#include "featurematching.h"
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/features2d.hpp"
//#include "opencv2/xfeatures2d.hpp"


FeatureMatching::FeatureMatching(cv::Mat image1, cv::Mat image2, QPolygonF polyArea1, QPolygonF polyArea2):image1(image1),
    image2(image2),
    polyArea1(polyArea1),
    polyArea2(polyArea2)
{

}

/*void FeatureMatching::getSIFTKeyPoints()
{
    //ToDo: Maybe splitt the SITF key point extraction into tow threads
    std::vector<cv::KeyPoint> keyPoints;
    cv::Ptr<cv::FeatureDetector> detector = cv::xfeatures2d::SIFT::create();
    detector->detect(image1,keyPoints);
    if(!polyArea1.isEmpty()){
        qreal x1=0,x2=0,y1=0,y2=0;
        polyArea1.boundingRect().getCoords(&x1,&y1,&x2,&y2);

        for(std::vector<int>::size_type i = 0; i != keyPoints.size(); i++)
         {
           cv::KeyPoint tempPoint = keyPoints.at(i);

           QPointF probe(tempPoint.pt.x+x1,tempPoint.pt.y+y1);
            if(polyArea1.containsPoint(probe,Qt::OddEvenFill)){
                keyPoints1.push_back(tempPoint);
            }
        }
    }

    keyPoints.clear();
    detector->clear();
    detector = cv::xfeatures2d::SIFT::create();
    detector->detect(image2,keyPoints);
    if(!polyArea2.isEmpty()){
        qreal x1=0,x2=0,y1=0,y2=0;
        polyArea2.boundingRect().getCoords(&x1,&y1,&x2,&y2);

        for(std::vector<int>::size_type i = 0; i != keyPoints.size(); i++)
         {
           cv::KeyPoint tempPoint = keyPoints.at(i);

           QPointF probe(tempPoint.pt.x+x1,tempPoint.pt.y+y1);
            if(polyArea2.containsPoint(probe,Qt::OddEvenFill)){
                keyPoints2.push_back(tempPoint);
            }
        }
    }
}

void FeatureMatching::getSIFTDescriptors()
{

    cv::Ptr<cv::FeatureDetector> extractor = cv::xfeatures2d::SIFT::create();
    extractor->compute(image1, keyPoints1, descriptor1);

    extractor->clear();
    extractor->compute(image2, keyPoints2, descriptor2);
}

void FeatureMatching::matchSIFT()
{
    getSIFTKeyPoints();
    getSIFTDescriptors();

    cv::FlannBasedMatcher matcher;
    matcher.match(descriptor1, descriptor2, matches);
    qDebug()<<"stop";

}*/

void FeatureMatching::getORBKeyPoints()
{
    if(image1.empty()||image2.empty())
        return;
    //ToDo: Maybe splitt the SITF key point extraction into tow threads
    std::vector<cv::KeyPoint> keyPoints;
    cv::Ptr<cv::FeatureDetector> detector = cv::ORB::create();
    detector->detect(image1,keyPoints);
    if(!polyArea1.isEmpty()){
        qreal x1=0,x2=0,y1=0,y2=0;
        polyArea1.boundingRect().getCoords(&x1,&y1,&x2,&y2);

        for(std::vector<int>::size_type i = 0; i != keyPoints.size(); i++)
         {
           cv::KeyPoint tempPoint = keyPoints.at(i);

           QPointF probe(tempPoint.pt.x+x1,tempPoint.pt.y+y1);
            if(polyArea1.containsPoint(probe,Qt::OddEvenFill)){
                keyPoints1.push_back(tempPoint);
            }
        }
    }

    keyPoints.clear();
    detector->clear();
    detector = cv::ORB::create();
    detector->detect(image2,keyPoints);
    if(!polyArea2.isEmpty()){
        qreal x1=0,x2=0,y1=0,y2=0;
        polyArea2.boundingRect().getCoords(&x1,&y1,&x2,&y2);

        for(std::vector<int>::size_type i = 0; i != keyPoints.size(); i++)
         {
           cv::KeyPoint tempPoint = keyPoints.at(i);

           QPointF probe(tempPoint.pt.x+x1,tempPoint.pt.y+y1);
            if(polyArea2.containsPoint(probe,Qt::OddEvenFill)){
                keyPoints2.push_back(tempPoint);
            }
        }
    }
}

void FeatureMatching::getORBDescriptors()
{
    if(keyPoints1.empty()||keyPoints2.empty())
        return;
    cv::Ptr<cv::FeatureDetector> extractor = cv::ORB::create();
    extractor->compute(image1, keyPoints1, descriptor1);

    extractor->clear();
    extractor->compute(image2, keyPoints2, descriptor2);
}

void FeatureMatching::matchORB()
{
    getORBKeyPoints();
    getORBDescriptors();

    if(descriptor1.empty()||descriptor2.empty())
        return;

    cv::FlannBasedMatcher matcher(new cv::flann::LshIndexParams(20,10,2));
    matcher.match(descriptor1, descriptor2, matches);
}

void FeatureMatching::getGoodMatches(int distance)
{
   for( size_t i = 0; i < matches.size(); i++ ){
       if( matches[i].distance < distance){
           good_matches.push_back(matches[i]);
       }
   }
}
