#ifndef IMAGEPROCESS
#define IMAGEPROCESS

#include <QtCore>
#include <QPolygonF>
#include "opencv2/core.hpp"
#include "opencv2/highgui.hpp"

class ImageProcess
{
public:
    explicit ImageProcess(QString framePath);
    cv::Mat crop(QPolygonF polyArea);
    void getBoundingRect(QPolygonF polyArea, qreal &x1, qreal &x2, qreal &y1, qreal &y2);

private:
    void checkSize(qreal &x1, qreal &x2, qreal &y1, qreal &y2);
    cv::Mat image;

};

#endif // IMAGEPROCESS

