#include "polypointgraphicsitem.h"

#include <QBrush>
#include <QGraphicsScene>
#include <QDebug>

#include "../globalobjects.h"

PolyPointGraphicsItem::PolyPointGraphicsItem(QGraphicsScene *s, QPointF p) :
    move(0,0),
    position(p)
{
    QGraphicsRectItem* dummy = new QGraphicsRectItem;
    dummy->setPos(p);
    dummy->setZValue(2);
    s->addItem(dummy);
    this->setParentItem(dummy);


    setFlag(QGraphicsItem::ItemIsMovable, true);
    setFlag(QGraphicsItem::ItemIgnoresTransformations, true);
    radius = 3;
    setBrush(QBrush(Qt::green));
    setRect(-1.414*radius, -1.414*radius, 2.824*radius, 2.824*radius);
}

void PolyPointGraphicsItem::mouseMoveEvent(QGraphicsSceneMouseEvent *event)
{
    QPointF mousePos = event->scenePos();

    QPointF threshMousePos = mousePos;
    QRectF imageRect = g_mainWindow->frameViewer->pixmapItem->sceneBoundingRect();
    threshMousePos.setX(qMin(imageRect.width(), qMax(imageRect.x(), threshMousePos.x())));
    threshMousePos.setY(qMin(imageRect.height(), qMax(imageRect.y(), threshMousePos.y())));

    QPointF diff = threshMousePos - scenePos();
    move += diff;
    setPos(pos() + diff);

    emit moving();
}

void PolyPointGraphicsItem::mouseReleaseEvent(QGraphicsSceneMouseEvent *event)
{
    position += move;
    QGraphicsEllipseItem::mouseReleaseEvent(event);
    qDebug() << "moving point finished. emitting";
    emit moved();
}
