#include "clickablegraphicsview.h"

#include <QDebug>

ClickableGraphicsView::ClickableGraphicsView(QWidget *parent) :
    QGraphicsView(parent),
    pressed(false)
{

}

void ClickableGraphicsView::mousePressEvent(QMouseEvent *event)
{
    pressed = true;
    QGraphicsView::mousePressEvent(event);
}

void ClickableGraphicsView::mouseMoveEvent(QMouseEvent *event)
{
    if(pressed) emit clicked(event->pos());
}

void ClickableGraphicsView::mouseReleaseEvent(QMouseEvent *event)
{
    pressed = false;
    emit clicked(event->pos());
    QGraphicsView::mouseReleaseEvent(event);
}

//void ClickableGraphicsView::mouseDoubleClickEvent(QMouseEvent *event)
//{
//    qDebug() << "double click test";
//}


