#-------------------------------------------------
#
# Project created by QtCreator 2015-07-12T19:59:26
#
#-------------------------------------------------

ISEG_VERSION_MAJOR = 0
ISEG_VERSION_MINOR = 0
ISEG_VERSION_REVISION = 5

ISEG_VERSION = $${ISEG_VERSION_MAJOR}.$${ISEG_VERSION_MINOR}.$${ISEG_VERSION_REVISION}

DEFINES += ISEG_VERSION_MAJOR=$$ISEG_VERSION_MAJOR \
    ISEG_VERSION_MINOR=$$ISEG_VERSION_MINOR \
    ISEG_VERSION_REVISION=$$ISEG_VERSION_REVISION \
    ISEG_VERSION=\\\"$$ISEG_VERSION\\\"

message("iSeg Version: "$$ISEG_VERSION)


QT       += core gui concurrent

CONFIG += c++11

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

INCLUDEPATH += $PWD
DEPENDPATH += $PWD

TARGET = iSeg
TEMPLATE = app

SOURCES += \
    main.cpp

HEADERS += \
    globalobjects.h

# include modul folder
include(Features/Features.pri)
include(Models/Models.pri)
include(FrameViewer/FrameViewer.pri)
include(TimeLine/TimeLine.pri)
include(FrameNav/FrameNav.pri)
include(core/core.pri)



# include extra binfiles into the build folder for all build types

RESOURCES = $${PWD}/Resources/icons.qrc

win32:{
    contains(QMAKE_TARGET.arch, x86_64) {
    INCLUDEPATH += $$PWD/../3rdparty/opencv/win64/install/include/

    Release:{
        DEFINES += QT_NO_DEBUG_OUTPUT

        LIBS += -L$$PWD/../3rdparty/opencv/win64/install/x64/vc12/lib \
        -lopencv_core300 \
        -lopencv_highgui300 \
        -lopencv_videoio300 \
        -lopencv_features2d300 \
        -lopencv_flann300 \
        -lopencv_imgcodecs300\
        -lopencv_imgproc300

        # include extra binfiles into the release build folder for windows
        DESTDIR_WIN = $$OUT_PWD/release
        EXTRA_BINFILES +=\
            $${PWD}/../3rdparty/opencv/win64/install/x64/vc12/bin/opencv_core300.dll \
            $${PWD}/../3rdparty/opencv/win64/install/x64/vc12/bin/opencv_highgui300.dll \
            $${PWD}/../3rdparty/opencv/win64/install/x64/vc12/bin/opencv_imgcodecs300.dll \
            $${PWD}/../3rdparty/opencv/win64/install/x64/vc12/bin/opencv_imgproc300.dll \
            $${PWD}/../3rdparty/opencv/win64/install/x64/vc12/bin/opencv_videoio300.dll \
            $${PWD}/../3rdparty/opencv/win64/install/x64/vc12/bin/opencv_features2d300.dll \
            $${PWD}/../3rdparty/opencv/win64/install/x64/vc12/bin/opencv_flann300.dll \
            $$(QTDIR)/bin/Qt5Core.dll \
            $$(QTDIR)/bin/Qt5Gui.dll \
            $$(QTDIR)/bin/Qt5Widgets.dll \
            $$(QTDIR)/bin/Qt5Concurrent.dll \
            $$(windir)/SysWOW64/msvcp120.dll \
            $$(windir)/SysWOW64/msvcr120.dll

        EXTRA_BINFILES_platforms +=\
            $$(QTDIR)/plugins/platforms/qwindows.dll

        EXTRA_BINFILES_imageformats +=\
            $$(QTDIR)/plugins/imageformats/qico.dll \
            $$(QTDIR)/plugins/imageformats/qjpeg.dll
        }

    Debug:{
        LIBS += -L$$PWD/../3rdparty/opencv/win64/install/x64/vc12/lib \
        -lopencv_core300d \
        -lopencv_highgui300d \
        -lopencv_videoio300d \
        -lopencv_features2d300d \
        -lopencv_flann300d \
        -lopencv_imgcodecs300d\
        -lopencv_imgproc300d

        # include extra binfiles into the debug build folder for windows
        DESTDIR_WIN = $$OUT_PWD/debug
        EXTRA_BINFILES +=\
            $${PWD}/../3rdparty/opencv/win64/install/x64/vc12/bin/opencv_core300d.dll \
            $${PWD}/../3rdparty/opencv/win64/install/x64/vc12/bin/opencv_highgui300d.dll \
            $${PWD}/../3rdparty/opencv/win64/install/x64/vc12/bin/opencv_imgcodecs300d.dll \
            $${PWD}/../3rdparty/opencv/win64/install/x64/vc12/bin/opencv_imgproc300d.dll \
            $${PWD}/../3rdparty/opencv/win64/install/x64/vc12/bin/opencv_videoio300d.dll \
            $${PWD}/../3rdparty/opencv/win64/install/x64/vc12/bin/opencv_features2d300d.dll \
            $${PWD}/../3rdparty/opencv/win64/install/x64/vc12/bin/opencv_flann300d.dll \
            $$(QTDIR)/bin/Qt5Cored.dll \
            $$(QTDIR)/bin/Qt5Guid.dll \
            $$(QTDIR)/bin/Qt5Widgetsd.dll\
            $$(QTDIR)/bin/Qt5Concurrentd.dll\
            $$(windir)/SysWOW64/msvcp120d.dll \
            $$(windir)/SysWOW64/msvcr120d.dll


        EXTRA_BINFILES_platforms +=\
            $$(QTDIR)/plugins/platforms/qwindowsd.dll

        EXTRA_BINFILES_imageformats +=\
            $$(QTDIR)/plugins/imageformats/qicod.dll \
            $$(QTDIR)/plugins/imageformats/qjpeg.dll
        }
    }

    EXTRA_BINFILES +=\
       $${PWD}/../3rdparty/opencv/win64/install/x64/vc12/bin/opencv_ffmpeg300_64.dll \
       $$(QTDIR)/bin/icudt52.dll \
       $$(QTDIR)/bin/icuin52.dll \
       $$(QTDIR)/bin/icuuc52.dll

    EXTRA_BINFILES ~= s,/,\\,g #change / to \ for windows
    DESTDIR_WIN ~= s,/,\\,g

    for(FILE, EXTRA_BINFILES){
        QMAKE_POST_LINK += $$quote(cmd /c copy /y $${FILE} $${DESTDIR_WIN}$$escape_expand(\\n\\t))
    }

    DESTDIR_WIN_platforms = $$OUT_PWD/release/platforms
    EXTRA_BINFILES_platforms ~= s,/,\\,g #change / to \ for windows
    DESTDIR_WIN_platforms ~= s,/,\\,g
    QMAKE_POST_LINK+=$$quote(cmd /c if not exist $${DESTDIR_WIN_platforms} mkdir $${DESTDIR_WIN_platforms}$$escape_expand(\n\t))
    for(FILE,EXTRA_BINFILES_platforms){
            QMAKE_POST_LINK += $$quote(cmd /c copy /y $${FILE} $${DESTDIR_WIN_platforms}$$escape_expand(\n\t))
    }

    DESTDIR_WIN_imageformats = $$OUT_PWD/release/imageformats
    EXTRA_BINFILES_imageformats ~= s,/,\\,g #change / to \ for windows
    DESTDIR_WIN_imageformats ~= s,/,\\,g
    QMAKE_POST_LINK+=$$quote(cmd /c if not exist $${DESTDIR_WIN_imageformats} mkdir $${DESTDIR_WIN_imageformats}$$escape_expand(\n\t))
    for(FILE,EXTRA_BINFILES_imageformats){
            QMAKE_POST_LINK += $$quote(cmd /c copy /y $${FILE} $${DESTDIR_WIN_imageformats}$$escape_expand(\n\t))
    }

    RC_ICONS = $${PWD}/Resources/mainicon.ico

    Release:{
    DESTDIR_WIN = $$OUT_PWD/release/
    DESTDIR_WIN ~= s,/,\\,g
    QMAKE_POST_LINK+=$$quote(cmd /c DEL $${DESTDIR_WIN}*.obj$$escape_expand(\n\t))
    QMAKE_POST_LINK+=$$quote(cmd /c DEL $${DESTDIR_WIN}*.cpp$$escape_expand(\n\t))
    QMAKE_POST_LINK+=$$quote(cmd /c DEL $${DESTDIR_WIN}*.manifest$$escape_expand(\n\t))
    QMAKE_POST_LINK+=$$quote(cmd /c DEL $${DESTDIR_WIN}*.res$$escape_expand(\n\t))

    QMAKE_POST_LINK+=$$quote(cmd /c winrar a -ep1 -r "$${DESTDIR_WIN}iSeg_0_0_1_a_win64.zip" "$${DESTDIR_WIN}*.*"$$escape_expand(\n\t))
    }
}

unix:{
    !macx: INCLUDEPATH += $$PWD/../3rdparty/opencv/linux/include/
    macx: INCLUDEPATH += $$PWD/../3rdparty/opencv/mac/include/

    !macx: LIBS += -L$$PWD/../3rdparty/opencv/linux/lib
    macx: LIBS += -L$$PWD/../3rdparty/opencv/mac/lib

    LIBS += \
    -lopencv_core \
    -lopencv_highgui \
    -lopencv_videoio \
    -lopencv_features2d \
    -lopencv_flann \
    -lopencv_imgcodecs\
    -lopencv_imgproc

    CONFIG(release,debug|release){
        DEFINES += QT_NO_DEBUG_OUTPUT

        EXTRA_BINFILES +=\
            $${PWD}/../3rdparty/opencv/linux/lib/libopencv_core.so.3.0 \
            $${PWD}/../3rdparty/opencv/linux/lib/libopencv_highgui.so.3.0 \
            $${PWD}/../3rdparty/opencv/linux/lib/libopencv_imgcodecs.so.3.0 \
            $${PWD}/../3rdparty/opencv/linux/lib/libopencv_imgproc.so.3.0 \
            $${PWD}/../3rdparty/opencv/linux/lib/libopencv_videoio.so.3.0 \
            $${PWD}/../3rdparty/opencv/linux/lib/libopencv_features2d.so.3.0 \
            $${PWD}/../3rdparty/opencv/linux/lib/libopencv_flann.so.3.0 \
            $$(QTDIR)/lib/libQt5Widgets.so.5 \
            $$(QTDIR)/lib/libQt5Concurrent.so.5 \
            $$(QTDIR)/lib/libQt5Gui.so.5 \
            $$(QTDIR)/lib/libQt5Core.so.5 \
            $$(QTDIR)/lib/libQt5Test.so.5 \
            $$(QTDIR)/lib/libQt5OpenGL.so.5 \
            $$(QTDIR)/lib/libicui18n.so.52 \
            $$(QTDIR)/lib/libicuuc.so.52 \
            $$(QTDIR)/lib/libicudata.so.52 \
            $$(QTDIR)/lib/libQt5DBus.so.5\
            $${PWD}/Resources/iSeg.sh

        EXTRA_BINFILES_platforms +=\
            $$(QTDIR)/plugins/platforms/libqxcb.so

        EXTRA_BINFILES_imageformats +=\
            $$(QTDIR)/plugins/imageformats/libqico.so \
            $$(QTDIR)/plugins/imageformats/libqjpeg.so

        QMAKE_POST_LINK+=$$quote(rm -f $$OUT_PWD/*.o$$escape_expand(\n\t))
        QMAKE_POST_LINK+=$$quote(rm -f $$OUT_PWD/*.cpp$$escape_expand(\n\t))
        QMAKE_POST_LINK+=$$quote(rm -f $$OUT_PWD/Makefile$$escape_expand(\n\t))
    }

    for(FILE,EXTRA_BINFILES){
            QMAKE_POST_LINK += $$quote(cp $${FILE} $$OUT_PWD$$escape_expand(\n\t))
        }
         QMAKE_POST_LINK += $$quote(mkdir -p $$OUT_PWD/platforms/$$escape_expand(\n\t))
    for(FILE,EXTRA_BINFILES_platforms){
            QMAKE_POST_LINK += $$quote(cp $${FILE} $$OUT_PWD/platforms/$$escape_expand(\n\t))
        }
        QMAKE_POST_LINK += $$quote(mkdir -p $$OUT_PWD/imageformats/$$escape_expand(\n\t))
    for(FILE,EXTRA_BINFILES_imageformats){
            QMAKE_POST_LINK += $$quote(cp $${FILE} $$OUT_PWD/imageformats/$$escape_expand(\n\t))
        }

    macx:QMAKE_MACOSX_DEPLOYMENT_TARGET = 10.10
    macx: ICON = :icons/mainicon.icns

    CONFIG(release,debug|release){
        QMAKE_POST_LINK += $$quote(tar jcfv iSeg_0_0_1_b_linux.tar.bz2 *$$escape_expand(\n\t))
    }
}

INCLUDEPATH += $$PWD/../3rdparty/Eigen/include
